import matplotlib.pyplot as plt
import math
import numpy as np 


# compteur du nombre d'appels récursifs 
t_compteur = [0] 


def exp_rec(a,n) :
    """version récursive de l'exponentiation binaire de a^n"""
    t_compteur[0] = t_compteur[0] + 1 
    if n == 0 :
        return 1
    res = exp_rec(a,n//2) 
    if n%2 == 0 :
        return res*res
    else :
        return res*res*a

a = 3
exposant = 53

lst_x = [] #liste des exposants 
lst_y = [] #liste des appels récursifs 

% boucle pour récupérer le nombre d'appels récursifs en fonction de l'exposant 
for n in range(1,exposant) :
    t_compteur = [0] 
    exp_rec(a,n)
    lst_x.append(n)
    lst_y.append(t_compteur[0]) 

print(lst_x) 
print(lst_y)


#####
##
#
# Affichage graphique 
#
##
###

fig, ax = plt.subplots()
ax.plot(lst_x, lst_y, '.')

abscisse = np.arange(1, exposant, .02)
ordonnee0 = np.log(abscisse)/np.log(2)
ordonnee1 = 1+np.log(abscisse)/np.log(2)
ordonnee2 = 2+np.log(abscisse)/np.log(2)

ax.plot(abscisse,ordonnee0,':') 
ax.plot(abscisse,ordonnee1) 
ax.plot(abscisse,ordonnee2) 

ax.set(xlabel='exposant n', ylabel="nombre d'appels de la fonction exp_rec",
       title='Introduction à la fonction log en base 2')
ax.grid()

fig.savefig("graph.png") #sauvegarde de la figure
plt.show()

#
##
#####
